%bcond_without bootstrap

Name: rust
Version: 0.7
Release: 1.1.lr1
Summary: Safe, concurrent, practical programming language
License: MIT or Apache-2.0
Group: Development/Languages/Other
Url: http://www.rust-lang.org

Source0: http://static.rust-lang.org/dist/rust-0.7.tar.gz
Source1: rust-stage0-2013-06-23-f827561-linux-x86_64-caea3402663334d0a3967c21f58a860c060d5474.tar.bz2
Source2: rust-stage0-2013-06-23-f827561-linux-i386-b8f4a0f0c2250aa4d76ec1eb57c83bfae5725f93.tar.bz2

BuildRoot: %{_tmppath}/%{name}-%{version}-build

BuildRequires: gcc-c++
BuildRequires: python
BuildRequires: perl
BuildRequires: curl
BuildRequires: chrpath
%if %without bootstrap
BuildRequires: rust
%endif

# These lack a SONAME
%global __requires_exclude %{?__requires_exclude:__requires_exclude|}^libextra-
%global __requires_exclude %__requires_exclude|librust-
%global __requires_exclude %__requires_exclude|librustc-
%global __requires_exclude %__requires_exclude|librustdoc-
%global __requires_exclude %__requires_exclude|librusti-
%global __requires_exclude %__requires_exclude|librustpkg-
%global __requires_exclude %__requires_exclude|libstd-
%global __requires_exclude %__requires_exclude|libsyntax-

ExclusiveArch: x86_64 %{ix86}

%description
Rust is a curly-brace, block-structured expression language. It visually
resembles the C language family, but differs significantly in syntactic
and semantic details. Its design is oriented toward concerns of "programming
in the large", that is, of creating and maintaining boundaries -
both abstract and operational - that preserve large-system integrity,
availability and concurrency.

It supports a mixture of imperative procedural, concurrent actor,
object-oriented and pure functional styles. Rust also supports generic
programming and metaprogramming, in both static and dynamic styles.

%package devel
Summary: Development files for Rust

Requires: rust = %{version}-%{release}
Provides: rust-devel-static = %{version}-%{release}

%description devel
Binary files which cannot be dynamically loaded.

%prep
%setup -q
%if %with bootstrap
%ifarch x86_64
%setup -D -T -a 1
%else
%setup -D -T -a 2
%endif
%endif

%build
./configure \
    --build-triple=%{_host_cpu}-unknown-linux-gnu \
    --host-triples=%{_host_cpu}-unknown-linux-gnu \
    --target-triples=%{_target_cpu}-unknown-linux-gnu \
    --enable-local-rust \
    --local-rust-root=%{?with_bootstrap:rust-stage0}%{?without_bootstrap:%{_prefix}} \
    --prefix=%{_prefix}
%if %with bootstrap
mkdir -p %{_target_cpu}-unknown-linux-gnu/stage0/lib
cp rust-stage0/lib/libextra-a7c050cfd46b2c9a-0.7-pre.so %{_target_cpu}-unknown-linux-gnu/stage0/lib
%endif
make

%install
make install DESTDIR=$RPM_BUILD_ROOT

# Remove rpath.
{ find $RPM_BUILD_ROOT%{_bindir} -type f ;
    find $RPM_BUILD_ROOT -type f -name "*.so" ; } | xargs chrpath --delete

# Remove executable permission from the manual to prevent RPMLINT error.
chmod -x $RPM_BUILD_ROOT%{_mandir}/*/rust*

%post
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_bindir}/rust*
%{_mandir}/*/rust*
%{_prefix}/lib/*.so
%{_prefix}/lib/rustc
%exclude %{_prefix}/lib/rustc/%{_target_cpu}-unknown-linux-gnu/lib/*.a

%files devel
%defattr(-,root,root,-)
%{_prefix}/lib/rustc/%{_target_cpu}-unknown-linux-gnu/lib/*.a
